//---------------------------------------------------------------------------

#ifndef SignalH
#define SignalH
//---------------------------------------------------------------------------

#include <vector>
#include <string>

class Signal
{
private:
	float fData[32768];
	short data[32768];
public:
	Signal();
	enum E_WAVEFORM
	{
		WAVE_NONE = 0,
		WAVE_DC,
		WAVE_SINUS,
		WAVE_SQUARE,
		//WAVE_TRIANGLE,
		WAVE_LIMITER
	};
	struct S_WAVE
	{
		float fAmplitude;
		float fFrequency;
		float fPhase;			///< phase delay [degrees]
		enum E_WAVEFORM shape;
	};
	typedef std::vector<struct S_WAVE> ShapeDefVector;

	ShapeDefVector shape;

	/** \brief Generate samples
		\param shape vector of waveforms
		\param count requested samples count
		\param fDivX sampling time
		\param fDivY voltage per bit
		\return pointer to data vector, NULL on error
	*/
	short* Generate(unsigned int count, float fDivX, float fDivY);
	static int GetTypeDescription(int type, std::string &desc);
};

extern Signal signal;

#endif
